/***************************************************************************
 *
 * rw/locimpl.cc - Template definitions for the Standard Library locale
 *                 private implementation classes.
 *
 * $Id: locimpl.cc,v 1.17 1996/10/02 01:48:00 smithey Exp $
 *
 ***************************************************************************
 *
 * (c) Copyright 1994-1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/
#if defined(__DECCXX)
#   ifdef __PRAGMA_ENVIRONMENT
#      pragma __environment __save
#      pragma __environment __header_defaults
#   endif
#endif

#ifndef _RWSTD_NO_NAMESPACE
namespace __rwstd {
#endif

// -------------------------------------------
// Template digit_map<charT> member templates.
// -------------------------------------------

template <class charT>
void 
_RWSTDExport _RWSTD_IMP_DECL(digit_map)<charT>::init (const ctype<charT> &ct)
{
  ct.widen(punct_chars,punct_chars+sizeof punct_chars,punct_array);
  ct.widen(digit_chars,digit_chars+sizeof digit_chars,digit_array);
  memcpy(value_array,char_values,sizeof value_array);
  inited=true;
}

template <class charT>
inline const _RWSTD_IMP_DECL(digit_map)<charT>&
_RWSTD_IMP_DECL(digit_map)<charT>::get_digit_map (const ctype<charT>& ct)
{
  if (!ct.digit_map_.inited)
    (_RWSTD_CONST_CAST(_RWSTD_IMP_DECL(digit_map)<char_type>&,ct.digit_map_))
        .init(ct);
  return ct.digit_map_;
}

template <class charT>
int _RWSTDExport _RWSTD_IMP_DECL(digit_map)<charT>::eval (charT c) const {
  const charT *end=digit_array+sizeof value_array;
  for (const charT *p=digit_array; p<end; p++)
    if (*p==c)
      return value_array[p-digit_array];
  return -1;
}

inline 
const _RWSTD_IMP_DECL(digit_map)<char>&
_RWSTD_IMP_DECL(digit_map)<char>::get_digit_map (const ctype<char>& ct)
{
  return ct.digit_map_;
}

inline int _RWSTD_IMP_DECL(digit_map)<char>::eval (char c) const {
  int num=c;
  if ((num-='0')>9) {
    if (((num-=('A'-'0'))>5 && (num-=('a'-'A'))>5) || (num+=10)<10)
      num=-1;
  }
  return num;
}

// -----------------------------------------------
// Template numpunct_data<charT> member functions.
// -----------------------------------------------

template <class charT>
void _RWSTDExport _RWSTD_IMP_DECL(numpunct_data)<charT>::rw_init (void) {
  tf_defs_[0].s=tn_.c_str();
  tf_defs_[0].v=1;
  tf_defs_[1].s=fn_.c_str();
  tf_defs_[1].v=0;

  tf_map_.num_defs_=2 ;
  tf_map_.defs_=tf_defs_;
}


inline
_RWSTD_IMP_DECL(numpunct_init)<char>*
_RWSTD_IMP_DECL(fixup_numpunct_init)
    (_RWSTD_IMP_DECL(numpunct_init)<char> *init,char*)
{
  return init;
}

template <class charT>
_RWSTD_IMP_DECL(numpunct_init)<charT>*
_RWSTDExport _RWSTD_IMP_DECL(fixup_numpunct_init)
    (_RWSTD_IMP_DECL(numpunct_init)<char> *init,charT*)
{
  if (init->del_)
    delete[] (char*) init;
  return NULL;
}

template <class charT>
_RWSTD_IMP_DECL(numpunct_init)<charT>*
_RWSTDExport _RWSTD_IMP_DECL(numpunct_data)<charT>::get_init_by_name_
    (const char *name)
{
  return _RWSTD_IMP_DECL(fixup_numpunct_init)(get_named_init_(name),(charT*)0);
}

// ------------------------------------------------
// Template timepunct_data<charT> member templates.
// ------------------------------------------------

template <class charT>
_RWSTD_IMP_DECL(timepunct_data)<charT>::
_RWSTD_IMP_DECL(timepunct_data)
    (const _RWSTD_IMP_DECL(timepunct_init)<charT> &init)
{
  int i;
  for (i=0; i<7; i++) {
    dn_[i][0]=init.dn_[i][0];
    dn_[i][1]=init.dn_[i][1];
  }
  for (i=0; i<12; i++) {
    mn_[i][0]=init.mn_[i][0];
    mn_[i][1]=init.mn_[i][1];
  }
  ampm_[0]=init.ampm_[0];
  ampm_[1]=init.ampm_[1];
  bad_=init.bad_;
  for (i=0; i<100; i++)
    ord_[i]=init.ord_[i];
  for (i=0; i<sizeof pat_/sizeof pat_[0]; i++)
    pat_[i]=init.pat_[i];
}

template <class charT>
void _RWSTDExport _RWSTD_IMP_DECL(timepunct_data)<charT>::rw_init (void) {
  int i;
  for (i=0; i<7; i++) {
    dn_defs_[i][0].s=dn_[i][0].c_str();
    dn_defs_[i][0].v=i;
    dn_defs_[i][1].s=dn_[i][1].c_str();
    dn_defs_[i][1].v=i;
  }

  for (i=0; i<12; i++) {
    mn_defs_[i][0].s=mn_[i][0].c_str();
    mn_defs_[i][0].v=i;
    mn_defs_[i][1].s=mn_[i][1].c_str();
    mn_defs_[i][1].v=i;
  }

  dn_map_.num_defs_=7*2;
  dn_map_.defs_=&(dn_defs_[0][0]);
  mn_map_.num_defs_=12*2;
  mn_map_.defs_=&(mn_defs_[0][0]);
}

// -------------------------------------------------
// Template moneypunct_data<charT> member templates.
// -------------------------------------------------

template <class charT>
_RWSTD_IMP_DECL(moneypunct_data)<charT>::_RWSTD_IMP_DECL(moneypunct_data)
    (_RWSTD_IMP_DECL(moneypunct_init)<charT> *init)
{
  if (!init) {
    this->dp_=charT('.');
    this->ts_=charT(',');
    fd_=0;
  } else {
    this->dp_=init->dp_;
    this->ts_=init->ts_;
    this->gr_=init->gr_;
    cs_=init->cs_;
    ps_=init->ps_;
    ns_=init->ns_;
    fd_=init->fd_;
    pf_=init->pf_;
    nf_=init->nf_;

    if (init->del_)
      delete[] (char*) init;
  }
}

template <class charT>
void _RWSTDExport _RWSTD_IMP_DECL(moneypunct_data)<charT>::rw_init (void) { }


inline
_RWSTD_IMP_DECL(moneypunct_init)<char>*
_RWSTDExport _RWSTD_IMP_DECL(fixup_moneypunct_init)
    (_RWSTD_IMP_DECL(moneypunct_init)<char> *init,char*)
{
  return init;
}

template <class charT>
_RWSTD_IMP_DECL(moneypunct_init)<charT>*
_RWSTDExport _RWSTD_IMP_DECL(fixup_moneypunct_init)
    (_RWSTD_IMP_DECL(moneypunct_init)<char> *init,charT*)
{
  _RWSTD_IMP_DECL(moneypunct_init)<charT> *result = NULL;

  // This is just a sketch of what eventually has to happen.

  if (init) {
    const codecvt<charT,char,mbstate_t> &cvt =
        #ifndef _RWSTD_NO_TEMPLATE_ON_RETURN_TYPE
        use_facet<codecvt<charT,char,mbstate_t> >(locale::classic());
        #else
        use_facet(locale::classic(),(codecvt<charT,char,mbstate_t>*)0);
        #endif

    typedef basic_string<charT,char_traits<charT>,allocator<void> > s_type;
    s_type cs_=cvt.in(init->cs_);
    s_type ps_=cvt.in(init->ps_);
    s_type ns_=cvt.in(init->ns_);

    size_t extra_chars = strlen(init->gr_);
    size_t extra_charTs = cs_.length()+ps_.length()+ns_.length()+3;

    result=(_RWSTD_IMP_DECL(moneypunct_init)<charT>*)
        new char[sizeof(*result)+extra_chars+extra_charTs*sizeof(charT)];

    result->del_=true;
    result->dp_=charT(init->dp_);
    result->ts_=charT(init->ts_);
    result->fd_=init->fd_;
    result->pf_=init->pf_;
    result->nf_=init->nf_;

    size_t n;
    charT *p=(charT*) (result+1);
    result->cs_=char_traits<charT>::copy(p,cs_.c_str(),n=cs_.length());
    *(p+=n)++=0;
    result->ps_=char_traits<charT>::copy(p,ps_.c_str(),n=ps_.length());
    *(p+=n)++=0;
    result->ns_=char_traits<charT>::copy(p,ns_.c_str(),n=ns_.length());
    *(p+=n)++=0;

    result->gr_=strcpy((char*)(p+n),init->gr_);
  }

  if (init->del_)
    delete[] (char*) init;

  return result;
}

template <class charT>
_RWSTD_IMP_DECL(moneypunct_init)<charT>*
_RWSTDExport _RWSTD_IMP_DECL(moneypunct_data)<charT>::get_init_by_name_
    (const char *name,bool intl)
{
  return _RWSTD_IMP_DECL(fixup_moneypunct_init)
      (get_named_init_(name,intl),(charT*)0);
}

// ---------------------------------------------------------
// Implementation function template -- create_classic_facet.
// ---------------------------------------------------------

#if defined(__DECCXX) && !defined(__CXXLFIX758)
#else
inline ctype<char>* _RWSTD_IMP_DECL(create_classic_facet) (ctype<char>*) {
#if defined(__DECCXX) && defined(__STD_CFRONT) && !defined(__CXXCFIX4670)
  return new ctype<char>(0,false,1);
#else
  return new ctype<char>(NULL,false,1);
#endif
}
#endif

template <class Facet>
inline Facet* _RWSTD_IMP_DECL(create_classic_facet) (Facet*) {
 return new Facet(1);
}

// ---------------------------------------------
// Template facet_maker<Facet> member templates.
// ---------------------------------------------

#if defined(__DECCXX) && !defined(CXXLFIX730)
#else
template <class Facet>
_RWSTD_IMP_DECL(facet_imp) * 
_RWSTDExport _RWSTD_IMP_DECL(facet_maker)<Facet>::
    maker_func (int t, const char *name, size_t refs)
{
  if (t==0)
    return _RWSTD_IMP_DECL(create_classic_facet) ((Facet*)0);
  else if (t==1)
    return _RWSTD_IMP_DECL(create_native_facet) ((Facet*)0);
  else
    return _RWSTD_IMP_DECL(create_named_facet) ((Facet*)0,name,refs);
}
#endif

#ifndef _RWSTD_NO_NAMESPACE
} // namespace __rwstd
#endif

#if defined(__DECCXX)
#   ifdef __PRAGMA_ENVIRONMENT
#      pragma __environment __restore
#   endif
#endif
