#ifndef __CXXL_MUTEX_HXX
#define __CXXL_MUTEX_HXX
//
//
//  COPYRIGHT (C) DIGITAL EQUIPMENT CORPORATION 1995
//
//  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED
//  ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE
//  INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER
//  COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
//  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY
//  TRANSFERRED.
//
//  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE
//  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT
//  CORPORATION.
//
//  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS
//  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
//
//

//++
//  FACILITY:	DEC C++ Class Library
//
//  SUBSYSTEM:	The Mutex package.
//
//  MODULE:	Include file for the Mutex subpackage.
//
//  MODULE DESCRIPTION:
//
//
//  DESIGN ISSUES:
//
//--

//++
//  INCLUDE FILES
//--

#include <cxxl.hxx>

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment save
#   pragma __environment header_defaults
#else
#   if defined(__VMS) && defined(__DECCXX)
#      pragma __extern_model __save
#      pragma __extern_prefix __save
#      pragma __member_alignment __save
#   endif
#endif

class InternalMutex;

//
// Publicly visible Mutex class.  Make sure no inlining is done.
//
class Mutex {

  public:

#if defined(__VMS) && defined(__DECCXX)
#   pragma __extern_prefix __CXXL_PLAIN_FUNC_LINKAGE
#endif
     Mutex();
     ~Mutex();
     void lock();
     void unlock();

     // Return 1 if the mutex got locked, 0 otherwise.

     int tryLock();

  private:
     InternalMutex *ptr;

     // Disallow assignment and copy constructors.
     Mutex & operator=(const Mutex & rhs);
     Mutex(const Mutex &);
};

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment restore
#else
#   if defined(__VMS) && defined(__DECCXX)
#      pragma __extern_model  __restore
#      pragma __extern_prefix __restore
#      pragma __member_alignment __restore
#   endif
#endif

#endif /* __CXXL_MUTEX_HXX */
