/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright Compaq Computer Corporation, 2000                *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 */
/*
 * |-----------------------------------------------------------|
 * | Copyright (c) 1991 MIPS Computer Systems, Inc.            |
 * | All Rights Reserved                                       |
 * |-----------------------------------------------------------|
 * |          Restricted Rights Legend                         |
 * | Use, duplication, or disclosure by the Government is      |
 * | subject to restrictions as set forth in                   |
 * | subparagraph (c)(1)(ii) of the Rights in Technical        |
 * | Data and Computer Software Clause of DFARS 52.227-7013.   |
 * |         MIPS Computer Systems, Inc.                       |
 * |         950 DeGuigne Drive                                |
 * |         Sunnyvale, CA 94086                               |
 * |-----------------------------------------------------------|
 */
/* $Header: /share/buffer/build/rcs.dsk1/os/src/usr/include/alpha/linenum.h,v 1.1.6.2 1998/04/28 15:13:39 Randy_Lowell Exp $ */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/


#ifndef _LINENUM_H
#define _LINENUM_H

/*  There is one line number entry for every 
    "breakpointable" source line in a section.
    Line numbers are grouped on a per function
    basis; the first entry in a function grouping
    will have l_lnno = 0 and in place of physical
    address will be the symbol table index of
    the function name.
*/
struct lineno
{
	union
	{
		long	l_symndx ;	/* sym. table index of function name
						iff l_lnno == 0      */
		long	l_paddr ;	/* (physical) address of line number */
	}		l_addr ;
	unsigned short	l_lnno ;	/* line number */
} ;

#define	LINENO	struct lineno
#define	LINESZ	6	/* sizeof(LINENO) */


/* Commands used for extended source information */

#define ADD_PC              1    /* Add signed delta to pc, leb */
#define ADD_LINE            2    /* Add signed delta to line, leb */
#define SET_COL             3    /* Set unsigned column number, leb */
#define SET_FILE            4    /* Set file via unsigned index, leb */
#define SET_DATA_MODE       5    /* Set data mode, either 1 or 2 */
#define ADD_LINE_PC         6    /* Add signed line, pc deltas, leb, leb */
#define ADD_LINE_PC_COL     7    /* Signed line, pc delta, unsigned col */
#define SET_LINE            8    /* Set unsigned line #, leb */
#define SET_LINE_COL        9    /* Set unsigned line and column, leb, leb */

/* Some defines to aid in extended source encoding and decoding */

#define CMD_MASK  0x3f
#define MASK7b    0x7f
#define NEGb      0x40
#define ESCAPEb   0x80
#define CONTINUEb ESCAPEb
#define MARKb     ESCAPEb
#define RESUMEb   NEGb

#endif  /* _LINENUM_H */
